-- Lulu88520
-- Script pour le pack de benne maitre BMM
-- Ls-Modteam-France
-- @date  24/04/2015
-- http://www.ls-modteam-france.com

BMM = {};

function BMM.prerequisitesPresent(specializations)
	  return SpecializationUtil.hasSpecialization(Fillable, specializations) and SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function BMM:load(xmlFile)

	 self.toggleSupport = SpecializationUtil.callSpecializationsFunction("toggleSupport");  
    self.manualSupportAnimation = getXMLString(xmlFile, "vehicle.manualSupport#animationName");
    self.supportRangeIndex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.manualSupport#rangeIndex"));
    self.isInRangeSupport = false;
    self.isSupportDown = true;
 	
	self.animPortes = false;   
	
	self.playerinrange = false;	
		
	self.portesNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.portesNode#index"));	
   
	
	self.flexible = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flexible#index"));
    setVisibility(self.flexible, false);

    self.flexibleDetach = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flexibleDetach#index"));
    setVisibility(self.flexibleDetach, true);

	self.smokeParticleSystems = {};
    local entry = {};
      entry.ps = {};
      Utils.loadParticleSystem(xmlFile, entry.ps, "vehicle.smokeParticleSystem", self.components, false, nil, self.baseDirectory);
      if table.getn(entry.ps) > 0 then
          entry.isActive = false;
          table.insert(self.smokeParticleSystems, entry);
      end
      local i=0;
      while true do
          local baseName = string.format("vehicle.smokeParticleSystems.smokeParticleSystem(%d)", i);
          if not hasXMLProperty(xmlFile, baseName) then
              break;
          end;
          local entry = {};
          entry.ps = {};
          Utils.loadParticleSystem(xmlFile, entry.ps, baseName, self.components, false, nil, self.baseDirectory);
          if table.getn(entry.ps) > 0 then
              entry.isActive = false;
             entry.cuttingArea = i+1;
              table.insert(self.smokeParticleSystems, entry);
          end
          i = i+1;
      end;

	 self.elevation = false;
    self.sendElevation = false;
	self.barre = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.barre#index"));
    setVisibility(self.barre, true);

    self.barreElevation = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.barreElevation#index"));
    setVisibility(self.barreElevation, false);	
end;

function BMM:delete()
for _, entry in ipairs(self.smokeParticleSystems) do
          Utils.deleteParticleSystem(entry.ps);
          entry.isActive = false;
end; 
end;

function BMM:readStream(streamId, connection)
self.animPortes = streamReadBool(streamId);	
   local isSupportDown = streamReadBool(streamId);
	self:toggleSupport(isSupportDown, true); 
	  self.elevation = streamReadBool(streamId);
end;

function BMM:writeStream(streamId, connection)
streamWriteBool(streamId, self.animPortes);
streamWriteBool(streamId, self.isSupportDown); 
streamWriteBool(streamId, self.elevation); 
end;

function BMM:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BMM:keyEvent(unicode, sym, modifier, isDown) 
end;

function BMM:update(dt)
         if self:getIsActive() then		
		if self.isClient and self:getIsActiveForInput(false) and not self:hasInputConflictWithSelection() then
			-- Show warning about the support being down
			if self.isSupportDown then
				g_currentMission:addWarning(string.format(g_i18n:getText("BJR_SUPPORT_WARNING")), 0.018, 0.033);
			end;
		end;
	end;
         if self.supportRangeIndex then
		-- Manage key events for inrange support --
		if self.isInRangeSupport then
			if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
				if self.isSupportDown then
					self:toggleSupport(false);
				else
					self:toggleSupport(true);
				end;
			end;
			-- Display key when in range --
			if self.isSupportDown then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BJR_RAISE_SUPPORT")), InputBinding.LOWER_IMPLEMENT);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BJR_LOWER_SUPPORT")), InputBinding.LOWER_IMPLEMENT);
			end;
		end;
	end;
	
	    
	
	if self.sendanimPortes ~= self.animPortes then
    self.sendanimPortes = self.animPortes;
    animPortesEvent:sendEvent(self, self.animPortes);
end;

if self.sendElevation ~= self.elevation then
    self.sendElevation = self.elevation;
    ElevationEvent:sendEvent(self, self.elevation);
	end;

 if self:getIsActive() and self.isClient and self:getIsActiveForInput() then       
		if InputBinding.hasEvent(InputBinding.MAITRE_ELEVATION) then
			self.elevation = not self.elevation;    
		end;    
 end;
 
 if self.animationParts[2].currentPosition < 0.00001 and not self.elevation then
 setVisibility(self.barre, true);
 setVisibility(self.barreElevation, false); 
end;


if self.animationParts[2].currentPosition > 0.00001 and self.elevation then
 setVisibility(self.barre, false);
 setVisibility(self.barreElevation, true); 
end;

if self.elevation then 
                self:setAnimationTime(2, self.animationParts[2].animDuration);
else
		self:setAnimationTime(2, self.animationParts[2].startPosition);                                       
end;


	if self.playerinrange then
		if InputBinding.hasEvent(InputBinding.PORTES) and self.fillLevel <= 0 then
			self.animPortes = not self.animPortes			
		end;

		if self.animPortes then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Fermer_portes"), self.typeDesc), InputBinding.PORTES);
		else if self.fillLevel <= 0 then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Ouvrir_portes"), self.typeDesc), InputBinding.PORTES);
			end;
		end;
		
		if self.fillLevel > 0 then
		 g_currentMission:addExtraPrintText(g_i18n:getText("WARNING_BENNE_PLEINE"));
		 end;
	end;	

end;

function BMM:updateTick(dt)

 if self.supportRangeIndex then
		if g_currentMission.player ~= nil then
			-- Getting the distance between the player and the support
			local nearestDistance = 1.5; --max distance allowed
			local px, py, pz = getWorldTranslation(self.supportRangeIndex);
			local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				self.isInRangeSupport = true;
			else
				self.isInRangeSupport = false;
			end;
		end;
	else
		self.isInRangeSupport = false;
	end;

if self.isClient then               
  if self.animPortes then               
			   self:setAnimationTime(1, self.animationParts[1].animDuration)
          else       			
				self:setAnimationTime(1, self.animationParts[1].startPosition);       
	end;
end;    
  


  	if self.attacherVehicle and g_currentMission.player ~= nil then
		local nearestDistance = 2.0;
		local px, py, pz = getWorldTranslation(self.portesNode);
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.playerinrange = true;
		else
			self.playerinrange = false;
		end;
	end;
	
	if self.isClient then
               
               for _,ps in pairs(self.smokeParticleSystems) do                  
                  if (self.currentFillType == Fillable.FILLTYPE_MANURE or self.currentFillType == Fillable.FILLTYPE_COMPOST_SOIL) and self.fillLevel > 3000 and self.movingDirection == 0 then                       
                      Utils.setEmittingState(ps.ps, true);
                  else
                      Utils.setEmittingState(ps.ps, false);
                  end
               end
end;
	
	for _, part in pairs(self.movingParts) do
		part.isDirty = true;
	end;
	for _, tool in pairs(self.movingTools) do
		tool.isDirty = true;
	end;	
end;

function BMM:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local isSupportDown = Utils.getNoNil(getXMLBool(xmlFile, key .. "#isSupportDown"), false);
	self:toggleSupport(isSupportDown);	
	
    return BaseMission.VEHICLE_LOAD_OK;
end;

function BMM:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'isSupportDown="' .. tostring(self.isSupportDown) .. '"';
    return attributes, nil;
end;
  
function BMM:onDetach()
setVisibility(self.flexible, false);
 setVisibility(self.flexibleDetach, true); 
end;

function BMM:onAttach()
setVisibility(self.flexible, true);
 setVisibility(self.flexibleDetach, false);
end;

function BMM:draw() 
if g_currentMission.showHelpText and self.isClient then
      g_currentMission:addExtraPrintText(g_i18n:getText("AIDE"));
	g_currentMission:addHelpButtonText(string.format(g_i18n:getText("MAITRE_ELEVATION"), self.typeDesc), InputBinding.MAITRE_ELEVATION); 
end;
end;

function BMM:toggleSupport(isSupportDown, noEventSend)
	ToggleSupportEvent.sendEvent(self, isSupportDown, noEventSend);	
	
	if not isSupportDown then
		if self.manualSupportAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualSupportAnimation, -1, nil, true);
		end;
	else
		if self.manualSupportAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualSupportAnimation, 1, nil, true);
		end;
	end;
	
	self.isSupportDown = isSupportDown;
end;



animPortesEvent = {};
animPortesEvent_mt = Class(animPortesEvent, Event);

InitEventClass(animPortesEvent, "animPortesEvent");

function animPortesEvent:emptyNew()
  local self = Event:new(animPortesEvent_mt);
  self.className="animPortesEvent";
  return self;
end;

function animPortesEvent:new(object, animPortes)
  local self = animPortesEvent:emptyNew();
  self.object = object;
  self.animPortes = animPortes;
  return self;
end;

function animPortesEvent:readStream(streamId, connection)
  self.object = networkGetObject(streamReadInt32(streamId));
  self.animPortes = streamReadBool(streamId);
  self:run(connection);
end;

function animPortesEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object));
  streamWriteBool(streamId, self.animPortes);
end;

function animPortesEvent:run(connection)
  self.object.animPortes = self.animPortes;  
  if not connection:getIsServer() then
    g_server:broadcastEvent(animPortesEvent:new(self.object, self.animPortes), nil, connection, self.object);
  end;
end;

function animPortesEvent:sendEvent(object, animPortes, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(animPortesEvent:new(object, animPortes), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(animPortesEvent:new(object, animPortes));
    end;
  end;
end;

-- Support event

ToggleSupportEvent = {};
ToggleSupportEvent_mt = Class(ToggleSupportEvent, Event);

InitEventClass(ToggleSupportEvent, "ToggleSupportEvent");

function ToggleSupportEvent:emptyNew()
    local self = Event:new(ToggleSupportEvent_mt);
    return self;
end;

function ToggleSupportEvent:new(object, isSupportDown)
    local self = ToggleSupportEvent:emptyNew()
    self.object = object;
	self.isSupportDown = isSupportDown;
    return self;
end;

function ToggleSupportEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.isSupportDown = streamReadBool(streamId);
    self:run(connection);
end;

function ToggleSupportEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));	
	streamWriteBool(streamId, self.isSupportDown);
end;

function ToggleSupportEvent:run(connection)
	self.object:toggleSupport(self.isSupportDown, true);
end;

function ToggleSupportEvent.sendEvent(object, isSupportDown, noEventSend)
	
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(ToggleSupportEvent:new(object, isSupportDown), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(ToggleSupportEvent:new(object, isSupportDown));
		end;
	end;
end;

if g_currentModName ~= "Pack_Maitre_BMM" then
	print("Error: The mod must not be renamed. It must be called Pack_Maitre_BMM.zip");
	print("Erreur: Le mods ne doit pas être renommé. Il doit être appelé Pack_Maitre_BMM.zip");		
end;

ElevationEvent = {};
ElevationEvent_mt = Class(ElevationEvent, Event);

InitEventClass(ElevationEvent, "ElevationEvent");

function ElevationEvent:emptyNew()
  local self = Event:new(ElevationEvent_mt);
  self.className="ElevationEvent";
  return self;
end;

function ElevationEvent:new(object, elevation)
  local self = ElevationEvent:emptyNew();
  self.object = object;
  self.elevation = elevation;
  return self;
end;

function ElevationEvent:readStream(streamId, connection)
  self.object = networkGetObject(streamReadInt32(streamId));
  self.elevation = streamReadBool(streamId);
  self:run(connection);
end;

function ElevationEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object));
  streamWriteBool(streamId, self.elevation);
end;

function ElevationEvent:run(connection)
  self.object.elevation = self.elevation;  
  if not connection:getIsServer() then
    g_server:broadcastEvent(ElevationEvent:new(self.object, self.elevation), nil, connection, self.object);
  end;
end;

function ElevationEvent:sendEvent(object, elevation, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(ElevationEvent:new(object, elevation), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(ElevationEvent:new(object, elevation));
    end;
  end;
end;